
#include <Servo.h>

// servo stuff
int servoPin = 11;
int pos = 90;    // variable to store the servo position
int dpos = 1;  // increments
int servoDir = 1; //increment 
Servo myservo;  // create servo object to control a servo

//ultrasonic stuff
const int trigPin = 13;
const int echoPin = 12;
long duration;
int distance;

void check_obstacles()
{
   distance = read_distance();
   if (distance>=5.0) 
   {
   pos+=servoDir*dpos;
   }
   myservo.write(pos);
   delay(50); 
   
   if (pos>=180)
   {
    servoDir = -1; 
   }
   else if(pos<=0)
   {
    servoDir = +1;
   }
 
   Serial.print("Distance: ");
   Serial.println(distance); 
}

long read_distance()
{
  // Clears the trigPin
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  
  // Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);
  
  // Calculating the distance
  distance= duration*0.034/2;
  
  // Prints the distance on the Serial Monitor
//  Serial.print("Distance: ");
//  Serial.println(distance);

  return distance; //returns the distance
}

void setup() {
  //servo stuff
  myservo.attach(servoPin); 
  myservo.write(pos); //might need calibration

  //ultrasonic stuff 
  pinMode(trigPin, OUTPUT); // Sets the trigPin as an Output
  pinMode(echoPin, INPUT); // Sets the echoPin as an Input

  Serial.begin(9600); // Starts the serial communication
  }
  

void loop() {
  check_obstacles();
}
